import React, { Fragment } from 'react'
import 'react-tippy/dist/tippy.css'
import { Tooltip } from 'react-tippy'
import { ThemeProvider, withTheme } from 'styled-components'

import { IconButton } from './'

const IconTooltip = ({
  theme,
  primary,
  interactive,
  icon = 'help-circle',
  iconSize = 3,
  ...rest
}) => (
  <Tooltip
    arrow
    data-test-id="icon-tooltip"
    html={<InfoTooltip theme={theme} {...rest} />}
    interactive={interactive}
    position="bottom"
    theme="light"
    trigger="click"
  >
    <IconButton icon={icon} iconSize={iconSize} mt={1 / 4} primary={primary} />
  </Tooltip>
)

const InfoTooltip = ({ theme, content }) => (
  <ThemeProvider theme={theme}>
    <Fragment>{typeof content === 'function' ? content() : content}</Fragment>
  </ThemeProvider>
)

export default withTheme(IconTooltip)
